(document:surround "/std/frame")

width 650
height 400

(gridbox columns "0;100"
         (hbox colspan 2 align "middle"
         (document:id faces
                      (listbox name "faces"
                               row '#((name . pixmap))
                               enumref "/users/read_face"
                  (when selected (ui-display))
                  (when double-clicked (ui-apply))))
         (document:id face (label align "center" name "face" pixmap
                                  (woo-get-option (woo-read-first "/users/view_face") 'face))))
         (label colspan 2)
         (hbox colspan 2 align "hmiddle"
               (button (_ "Choose") name "choose")
               (button (_ "Cancel") name "cancel")))

(define (ui-apply)
  (catch/message
    (lambda()
      (woo-write "/users/write_face" 'face (face pixmap))
      (document:end #f))))

(define (ui-cancel)
  (document:end #f))

(define (ui-display)
  (face pixmap (cdr (faces row-item (faces current)))))

(define (ui-init)
  (form-bind "choose" "click" ui-apply)
  (form-bind "cancel" "click" ui-cancel))

(document:root (when loaded (ui-init)))
